package nccloud.zjnytwo_cd.zjnytwo_cd.bankaccountshvo.action;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsBVO;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsBillVO;
import nc.vo.zjnytwo_cd.bankaccounts.BankaccountsHVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.io.WebFile;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.zjnytwo_cd.zjnytwo_cd.BankaccountsHVOConst;
import nccloud.zjnytwo_cd.zjnytwo_cd.bankaccountshvo.zjnytwo_cd.util.CommonUtil;
import nccloud.zjnytwo_cd.zjnytwo_cd.tool.Excel;

/**
 * 银行账户填报单导入
 * @author LP
 *
 */
public class BankaccountsHVOImportAction implements ICommonAction {

	public String group;
	public String org;
	public String org_v;
	public int month;
	
	public BaseDAO dao;
	public IMDPersistenceQueryService qryService;
	
	@Override
	public Object doAction(IRequest paramIRequest) {
		
		WebFile[] readFiles = paramIRequest.readFiles();
		
		WebFile file = readFiles[0];
		
		try {
			
			dao = new BaseDAO();
			qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
			
			JSONArray jsonArray = Excel.readXLSX(file);//解析Excel
			
			BankaccountsBillVO bankaccountsBillVO = setBankaccountsBillVO(jsonArray);
			
			saveBankaccountsBillVO(bankaccountsBillVO);
			
		} catch (Exception e) {
			Logger.error(e);
		    ExceptionUtils.wrapException(e);
		}
		
		return null;
	}
	
	/*
	 * 保存VO
	 */
	private void saveBankaccountsBillVO(BankaccountsBillVO bankaccountsBillVO) throws BusinessException {
		
		String oldbankaccount = SqlQuery("pk_bankaccount", "zjnytwo_cd_bankaccounts_h", "month", String.valueOf(month));
		
		if (oldbankaccount!=null) {
			BankaccountsBillVO oldBankaccountsBillVO = getVO(oldbankaccount);
			deleteVO(oldBankaccountsBillVO);//删除VO
		}
		saveVO(bankaccountsBillVO);
	}
	
	/*
	 * 组合BankaccountsBillVO
	 */
	private BankaccountsBillVO setBankaccountsBillVO(JSONArray jsonArray) throws Exception {
		
		BankaccountsBillVO bankaccountsBillVO = new BankaccountsBillVO();
		
		JSONArray headArray = jsonArray.getJSONArray(0);//表头
		JSONArray bodylArray = jsonArray.getJSONArray(1);//表体
		
		BankaccountsHVO headHvo = sethead(headArray);
		BankaccountsBVO[] bodyBvo = setbody(bodylArray);
		
		bankaccountsBillVO.setParentVO(headHvo);
		bankaccountsBillVO.setChildrenVO(bodyBvo);
		
		return bankaccountsBillVO;
	}
	
	/*
	 * 导入表头
	 */
	private BankaccountsHVO sethead(JSONArray headArray) throws Exception {
		
		BankaccountsHVO bankaccountsHVO = new BankaccountsHVO();
		JSONObject headObject = headArray.getJSONObject(0);
		
		String enablestate = headObject.getString("启用");
		
		if (headArray.size()>1) {
			throw new Exception("表头不允许有多列！请检查数据的合法性或Excel表格是否符合规范！");
		}
		
		if (enablestate==null) {
			throw new Exception("启用为必填项，请检查！");
		}
		
		if(enablestate.equals("Y")) {
			bankaccountsHVO.setEnablestate(2);
		}else if(enablestate.equals("N")) {
			bankaccountsHVO.setEnablestate(3);
		}else {
			throw new Exception("启用只允许填写'N'和'Y'，请检查！");
		}
		
		group = SqlQuery("pk_group", "org_group", "code", headObject.getString("集团"));
		org = SqlQuery("pk_org", "org_orgs", "code", headObject.getString("组织"));
		org_v = SqlQuery("pk_vid", "org_orgs_v", "code", headObject.getString("组织"));;
		
		bankaccountsHVO.setPk_group(group);
		bankaccountsHVO.setPk_org(org);
		bankaccountsHVO.setPk_org_v(headObject.getString("组织"));
		
//		Calendar calendar = Calendar.getInstance();
//		month = calendar.get(Calendar.MONTH) + 1; 
		month = Integer.valueOf(headObject.getString("月份"));
		bankaccountsHVO.setMonth(month);//月份
		
		Date date = new Date();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd"); 
		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 
		String Inputdate = formatter.format(date);
		String Dbilldate = formatter2.format(date);
		bankaccountsHVO.setInputdate(new UFDate(Inputdate));//导入日期
		bankaccountsHVO.setDbilldate(new UFDateTime(Dbilldate));//单据日期
		
		bankaccountsHVO.setInputman(SqlQuery("cuserid", "sm_user", "user_code", headObject.getString("导入人")));
		bankaccountsHVO.setCode(headObject.getString("编码"));
		bankaccountsHVO.setName(headObject.getString("名称"));
		bankaccountsHVO.setVnote(headObject.getString("备注"));
		
		return bankaccountsHVO;
		
	}
	
	/*
	 * 导入表体
	 */
	private BankaccountsBVO[] setbody(JSONArray bodylArray) throws DAOException {
		
		BankaccountsBVO[] bvos = new BankaccountsBVO[bodylArray.size()];
		
		for(int i = 0 ; i < bodylArray.size() ; i++ ) {
			
			JSONObject bodyobject = bodylArray.getJSONObject(i);
			
			BankaccountsBVO bankaccountsBVO = new BankaccountsBVO();
			
			bankaccountsBVO.setPk_group(group);
			bankaccountsBVO.setPk_org(org);
			bankaccountsBVO.setPk_org_v(org_v);
			bankaccountsBVO.setCrowno(bodyobject.getString("行号"));
			bankaccountsBVO.setUnit(SqlQuery("pk_org", "org_orgs", "code", bodyobject.getString("一级单位")));
			bankaccountsBVO.setAccountunit(SqlQuery("pk_org", "org_orgs", "code", bodyobject.getString("开户单位")));
			bankaccountsBVO.setAccountbank(bodyobject.getString("开户银行"));
			bankaccountsBVO.setAccount(bodyobject.getString("账号"));
			bankaccountsBVO.setCurrency(bodyobject.getString("币种"));
			bankaccountsBVO.setAccounttype(bodyobject.getString("账户类型"));
			bankaccountsBVO.setAccountdate(new UFDate(bodyobject.getString("开户日期")));
			bankaccountsBVO.setBankoperator(bodyobject.getString("网银操作员"));
			bankaccountsBVO.setBankreviewer(bodyobject.getString("网银复核员"));
			bankaccountsBVO.setBankadmin(bodyobject.getString("网银管理员"));
			bankaccountsBVO.setIssigned(bodyobject.getString("是否签订U盾证书"));
			bankaccountsBVO.setU_code(bodyobject.getString("U盾编码"));
			bankaccountsBVO.setBankstate(bodyobject.getString("网银开通状态"));
			bankaccountsBVO.setBankcheck(bodyobject.getString("网银登记单"));
			bankaccountsBVO.setVbnote(bodyobject.getString("行备注"));
			
			bvos[i] = bankaccountsBVO;
		}
		
		return bvos;
	}
	
	/*
	 * VO查询方法
	 */
	@SuppressWarnings("unchecked")
	private BankaccountsBillVO getVO(String pk_bankaccount) throws MetaDataException {
		ArrayList<BankaccountsBillVO> AggVOs = (ArrayList<BankaccountsBillVO>) qryService.queryBillOfVOByCond(BankaccountsBillVO.class,"pk_bankaccount = '"+pk_bankaccount+"' and dr = '0'",true,false);
		
		BankaccountsBillVO bankaccountsBillVO = AggVOs.get(0);
		
		return bankaccountsBillVO;
	}
	
	/*
	 * SQL查询方法
	 */
	private String SqlQuery(String out,String table,String lock,String key) throws DAOException {
		
		if (key==null) {
			return null;
		}
		
		String sql = "select "+out+" from "+table+" where "+lock+" = '"+key+"' and dr = '0'";
		
		Object object = dao.executeQuery(sql, new ColumnProcessor());
		
		if (lock.equals("month") && object == null) {
			return null;
		}else if (object == null) {
			throw new DAOException("根据值"+key+"在数据库中未查到相应的数据，请检查！");
		}
		
		return object.toString();
	}
	
	/*
	 * 删除脚本
	 */
	@SuppressWarnings({ "unchecked", "unused" })
	private BankaccountsBillVO deleteVO(BankaccountsBillVO... aggVOs)
		      throws BusinessException {

		    String actionCode = BankaccountsHVOConst.CONST_ACTION_DELETE;
		    String billType = BankaccountsHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service =
		        CommonUtil.getCloudScriptPFlowService();

		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug("调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]结束");

		    String wheresql =
		        "pk_bankaccount" + "='"
		            + ((BankaccountsBillVO) result[0]).getPrimaryKey() + "'";
		    Collection<BankaccountsBillVO> bills =
		        CommonUtil.getMDPersistenceQueryService().queryBillOfVOByCond(
		            BankaccountsBillVO.class, wheresql, true, false);
//		    return bills.toArray(new BankaccountsBillVO[0])[0];
		    return null;
	}
	
	/*
	 * 保存脚本
	 */
	@SuppressWarnings("unchecked")
	private BankaccountsBillVO saveVO(BankaccountsBillVO... aggVOs)
		      throws BusinessException {

		    String actionCode = BankaccountsHVOConst.CONST_ACTION_SAVEBASE;
		    String billType = BankaccountsHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service =
		        CommonUtil.getCloudScriptPFlowService();

		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug("调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]结束");

		    String wheresql =
		        "pk_bankaccount" + "='"
		            + ((BankaccountsBillVO) result[0]).getPrimaryKey() + "'";
		    Collection<BankaccountsBillVO> bills =
		        CommonUtil.getMDPersistenceQueryService().queryBillOfVOByCond(
		            BankaccountsBillVO.class, wheresql, true, false);
		    return bills.toArray(new BankaccountsBillVO[0])[0];
	}

}
