
package nccloud.zjnytwo_cd.zjnytwo_cd.bankloanhvo.action;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.logging.Logger;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.zjnytwo_cd.bankloan.BankloanBillVO;
import nc.vo.zjnytwo_cd.bankloan.BankloanHVO;
import nc.vo.zjnytwo_cd.bankloan.BankloanBVO;

import nc.vo.pub.BusinessException;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.billcard.BillCard;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.zjnytwo_cd.zjnytwo_cd.bankloanhvo.zjnytwo_cd.bean.PageQueryInfo;
import nccloud.zjnytwo_cd.zjnytwo_cd.bankloanhvo.zjnytwo_cd.util.CommonUtil;

/**
* 卡片查询（查询方案）操作
* @version  @since v3.5.6-1903
*/
public class BankloanHVOQueryCardAction implements ICommonAction {

@Override
public Object doAction(IRequest paramIRequest) {
PageQueryInfo queryParam = this.getQueryParam(paramIRequest);
try {
// 查询数据
Collection<BankloanBillVO> bills = this.queryBills(queryParam);


List<BankloanBillVO> billsList = new ArrayList<>(bills);
if (!billsList.isEmpty()) {
for (BankloanBillVO vo : billsList) {
if (vo.getChildren(BankloanBVO.class) == null) {
String con = "pk_bankloan='" + vo.getParentVO().getPk_bankloan() + "'";
Collection<BankloanBVO> result = new BaseDAO().retrieveByClause(BankloanBVO.class, con);
List<BankloanBVO> childs = new ArrayList<>(result);
if (!childs.isEmpty()) {
BankloanBVO[] childArray = new BankloanBVO[childs.size()];
childs.toArray(childArray);
vo.setChildren(BankloanBVO.class, childArray);
}
}
}
}
return this.transBillCard(queryParam, bills);
}
catch (BusinessException ex) {
// 处理异常信息
Logger.error(ex);
ExceptionUtils.wrapException(ex);
}
return null;
}

/**
* 获取查询参数
*
* @param paramIRequest
* @return
*/
private PageQueryInfo getQueryParam(IRequest paramIRequest) {
String strRead = paramIRequest.read();
PageQueryInfo queryParam =
JsonFactory.create().fromJson(strRead, PageQueryInfo.class);
return queryParam;
}

/**
* 查询业务数据
*
* @param queryParam
* @return
* @throws MetaDataException
*/
private Collection<BankloanBillVO> queryBills(PageQueryInfo queryParam)
throws MetaDataException {
IMDPersistenceQueryService service = CommonUtil.getMDPersistenceQueryService();
// 注意：业务提供查询方法（元数据查询默认查询到dr=1的数据了）
String wheresql =
"pk_bankloan" + "='" + queryParam.getPk() + "'";
Collection<BankloanBillVO> bills =
service.queryBillOfVOByCond(BankloanBillVO.class, wheresql, true,
false);
return bills;
}

/**
* VO 转换
*
* @param queryParam
* @param bill
* @return
*/
private BillCard transBillCard(PageQueryInfo queryParam,
Collection<BankloanBillVO> bills) {
if (bills == null) {
return null;
}
BankloanBillVO bill = bills.toArray(new BankloanBillVO[0])[0];
BillCardOperator operator = new BillCardOperator(queryParam.getPagecode());
return operator.toCard(bill);
}
}
