package nccloud.zjnytwo_cd.zjnytwo_cd.lettercredithvo.action;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.zjnytwo_cd.lettercredit.LettercreditBVO;
import nc.vo.zjnytwo_cd.lettercredit.LettercreditBillVO;
import nc.vo.zjnytwo_cd.lettercredit.LettercreditHVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.io.WebFile;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.zjnytwo_cd.zjnytwo_cd.LettercreditHVOConst;
import nccloud.zjnytwo_cd.zjnytwo_cd.lettercredithvo.zjnytwo_cd.util.CommonUtil;
import nccloud.zjnytwo_cd.zjnytwo_cd.tool.Excel;

/**
 * 信用证承兑汇票导入
 * @author LP
 *
 */
public class LettercreditHVOImportAction implements ICommonAction {
	
	public String group;
	public String org;
	public String org_v;
	public int month;
	
	public BaseDAO dao;
	public IMDPersistenceQueryService qryService;

	@Override
	public Object doAction(IRequest paramIRequest) {
		
		WebFile[] readFiles = paramIRequest.readFiles();
		
		WebFile file = readFiles[0];
		
		try {
			
			dao = new BaseDAO();
			qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
			
			JSONArray jsonArray = Excel.readXLSX(file);//解析Excel
			
			LettercreditBillVO lettercreditBillVO = setLettercreditBillVO(jsonArray);
			
			saveLettercreditBillVO(lettercreditBillVO);
			
		} catch (Exception e) {
			Logger.error(e);
		    ExceptionUtils.wrapException(e);
		}
		return null;
	}
	
	/*
	 * 保存VO
	 */
	private void saveLettercreditBillVO(LettercreditBillVO lettercreditBillVO) throws BusinessException {
		
		String oldbankaccount = SqlQuery("pk_lettercredit", "zjnytwo_cd_lettercredit_h", "month", String.valueOf(month));
		
		if (oldbankaccount!=null) {
			LettercreditBillVO oldBankaccountsBillVO = getVO(oldbankaccount);
			deleteVO(oldBankaccountsBillVO);//删除VO
		}
		saveVO(lettercreditBillVO);
		
	}
	
	/*
	 * 组合LettercreditBillVO
	 */
	private LettercreditBillVO setLettercreditBillVO(JSONArray jsonArray) throws Exception {
		
		LettercreditBillVO lettercreditBillVO = new LettercreditBillVO();
		
		JSONArray headArray = jsonArray.getJSONArray(0);//表头
		JSONArray bodylArray = jsonArray.getJSONArray(1);//表体
		
		LettercreditHVO headHvo = sethead(headArray);
		LettercreditBVO[] bodyBvo = setbody(bodylArray);
		
		lettercreditBillVO.setParentVO(headHvo);
		lettercreditBillVO.setChildrenVO(bodyBvo);
		
		return lettercreditBillVO;
	}
	
	/*
	 * 导入表头
	 */
	private LettercreditHVO sethead(JSONArray headArray) throws Exception {
		
		LettercreditHVO lettercreditHVO = new LettercreditHVO();
		JSONObject headObject = headArray.getJSONObject(0);
		
		String enablestate = headObject.getString("启用");
		
		if (headArray.size()>1) {
			throw new Exception("表头不允许有多列！请检查数据的合法性或Excel表格是否符合规范！");
		}
		
		if (enablestate==null) {
			throw new Exception("启用为必填项，请检查！");
		}
		
		if(enablestate.equals("Y")) {
			lettercreditHVO.setEnablestate(2);
		}else if(enablestate.equals("N")) {
			lettercreditHVO.setEnablestate(3);
		}else {
			throw new Exception("启用只允许填写'N'和'Y'，请检查！");
		}
		
		group = SqlQuery("pk_group", "org_group", "code", headObject.getString("集团"));
		org = SqlQuery("pk_org", "org_orgs", "code", headObject.getString("组织"));
		org_v = SqlQuery("pk_vid", "org_orgs_v", "code", headObject.getString("组织"));;
		
		lettercreditHVO.setPk_group(group);
		lettercreditHVO.setPk_org(org);
		lettercreditHVO.setPk_org_v(org_v);
		
		month = Integer.valueOf(headObject.getString("月份"));
		lettercreditHVO.setMonth(month);
		
		Date date = new Date();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd"); 
		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 
		String Inputdate = formatter.format(date);
		String Dbilldate = formatter2.format(date);
		lettercreditHVO.setInputdate(new UFDate(Inputdate));//导入日期
		lettercreditHVO.setDbilldate(new UFDateTime(Dbilldate));//单据日期
		
		lettercreditHVO.setInputman(SqlQuery("cuserid", "sm_user", "user_code", headObject.getString("导入人")));
		lettercreditHVO.setCode(headObject.getString("编码"));
		lettercreditHVO.setName(headObject.getString("名称"));
		lettercreditHVO.setVnote(headObject.getString("备注"));
		
		return lettercreditHVO;
	}
	
	/*
	 * 导入表体
	 */
	private LettercreditBVO[] setbody(JSONArray bodylArray) throws DAOException {
		
		LettercreditBVO[] lettercreditBVOs = new LettercreditBVO[bodylArray.size()];
		
		for(int i = 0 ; i < bodylArray.size() ; i++ ) {
			
			JSONObject bodyobject = bodylArray.getJSONObject(i);
			
			LettercreditBVO lettercreditBVO = new LettercreditBVO();
			
			lettercreditBVO.setPk_group(group);
			lettercreditBVO.setPk_org(org);
			lettercreditBVO.setPk_org_v(org_v);
			lettercreditBVO.setCrowno(bodyobject.getString("行号"));
			lettercreditBVO.setUnit(SqlQuery("pk_org", "org_orgs", "code", bodyobject.getString("一级单位")));
			lettercreditBVO.setUseunits(SqlQuery("pk_org", "org_orgs", "code", bodyobject.getString("使用单位")));
			lettercreditBVO.setBusinestype(bodyobject.getString("业务种类"));
			lettercreditBVO.setCode(bodyobject.getString("编号"));
			lettercreditBVO.setLssuingbank(bodyobject.getString("开证银行"));
			lettercreditBVO.setAmountbill(Integer.valueOf(bodyobject.getString("票据金额")));
			lettercreditBVO.setDeposit(Integer.valueOf(bodyobject.getString("保证金")));
			lettercreditBVO.setDepositproportion(bodyobject.getString("保证金比例"));
			lettercreditBVO.setCumulative(Integer.valueOf(bodyobject.getString("累计核销额")));
			lettercreditBVO.setRefundamount(Integer.valueOf(bodyobject.getString("退票金额")));
			lettercreditBVO.setBalancebill(Integer.valueOf(bodyobject.getString("票据余额")));
			lettercreditBVO.setStartdate(new UFDate(bodyobject.getString("业务起始日")));
			lettercreditBVO.setEnddate(new UFDate(bodyobject.getString("业务到期日")));
			lettercreditBVO.setTerm(bodyobject.getString("期限"));
			lettercreditBVO.setBank(bodyobject.getString("银行"));
			lettercreditBVO.setGuaranteetype(bodyobject.getString("担保方式"));
			lettercreditBVO.setGuaranteeunit(bodyobject.getString("担保单位"));
			lettercreditBVO.setVbnote(bodyobject.getString("备注"));
			
			lettercreditBVOs[i] = lettercreditBVO;
			
		}
		
		return lettercreditBVOs;
	}

	/*
	 * VO查询方法
	 */
	@SuppressWarnings("unchecked")
	private LettercreditBillVO getVO(String pk_lettercredit) throws MetaDataException {
		ArrayList<LettercreditBillVO> AggVOs = (ArrayList<LettercreditBillVO>) qryService.queryBillOfVOByCond(LettercreditBillVO.class,"pk_lettercredit = '"+pk_lettercredit+"' and dr = '0'",true,false);
		
		LettercreditBillVO bankaccountsBillVO = AggVOs.get(0);
		
		return bankaccountsBillVO;
	}
	
	/*
	 * SQL查询方法
	 */
	private String SqlQuery(String out,String table,String lock,String key) throws DAOException {
		
		if (key==null) {
			return null;
		}
		
		String sql = "select "+out+" from "+table+" where "+lock+" = '"+key+"' and dr = '0'";
		
		Object object = dao.executeQuery(sql, new ColumnProcessor());
		
		if (lock.equals("month") && object == null) {
			return null;
		}else if (object == null) {
			throw new DAOException("根据值"+key+"在数据库中未查到相应的数据，请检查！");
		}
		
		return object.toString();
	}
	
	/*
	 * 保存脚本
	 */
	@SuppressWarnings("unchecked")
	private LettercreditBillVO saveVO(LettercreditBillVO... aggVOs)
		      throws BusinessException {

		    String actionCode = LettercreditHVOConst.CONST_ACTION_SAVEBASE;
		    String billType = LettercreditHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service =
		        CommonUtil.getCloudScriptPFlowService();

		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug("调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]结束");

		    String wheresql =
		        "pk_lettercredit" + "='"
		            + ((LettercreditBillVO) result[0]).getPrimaryKey() + "'";
		    Collection<LettercreditBillVO> bills =
		        CommonUtil.getMDPersistenceQueryService().queryBillOfVOByCond(
		            LettercreditBillVO.class, wheresql, true, false);
		    return bills.toArray(new LettercreditBillVO[0])[0];
	}
	
	/*
	 * 删除脚本
	 */
	private Object deleteVO(LettercreditBillVO... aggVOs)
		      throws BusinessException {

		    if ((aggVOs == null) || (aggVOs.length == 0)) {
		      return null;
		    }

		    String actionCode = LettercreditHVOConst.CONST_ACTION_DELETE;
		    String billType = LettercreditHVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    Logger.debug("开始调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");

		    ICloudScriptPFlowService service = CommonUtil.getCloudScriptPFlowService();
		    Object[] result = service.exeScriptPFlow(context);

		    Logger.debug(
		        "调用动作脚本 ActionName[" + actionCode + "] BillType[" + billType + "]结束");

		    return result;
	}
}
