
package nccloud.impl.pub.ace;

import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVODeleteBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOInsertBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOUnApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOUnSendApproveBP;
import nccloud.bs.zjnytwo_cd.zjnytwo_cd.aggbusi.ace.bp.AceBankloanHVOUpdateBP;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.zjnytwo_cd.bankloan.BankloanBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public abstract class AceAggbusiBankloanHVOPubServiceImpl {
        // 新增
        public BankloanBillVO[] pubinsertBills(BankloanBillVO[] clientFullVOs,
                        BankloanBillVO[] originBills) throws BusinessException {
                try {
                        synchronized (clientFullVOs) {
                                // 数据库中数据和前台传递过来的差异VO合并后的结果
                                BillTransferTool<BankloanBillVO> transferTool = new BillTransferTool<BankloanBillVO>(
                                                clientFullVOs);
                                // 调用BP
                                AceBankloanHVOInsertBP action = new AceBankloanHVOInsertBP();
                                BankloanBillVO[] retvos = action.insert(clientFullVOs);
                                // 构造返回数据
        //                      return transferTool.getBillForToClient(retvos);
                                return retvos;
                        }
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        // 删除
        public void pubdeleteBills(BankloanBillVO[] clientFullVOs,
                        BankloanBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                    BillTransferTool<BankloanBillVO> transferTool =
                        new BillTransferTool<BankloanBillVO>(clientFullVOs);
                        // 调用BP
                        new AceBankloanHVODeleteBP().delete(clientFullVOs);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
        }

        // 修改
        public BankloanBillVO[] pubupdateBills(BankloanBillVO[] clientFullVOs,
                        BankloanBillVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                        BillTransferTool<BankloanBillVO> transferTool = new BillTransferTool<BankloanBillVO>(
                                        clientFullVOs);
                        AceBankloanHVOUpdateBP bp = new AceBankloanHVOUpdateBP();
                        BankloanBillVO[] retvos = bp.update(clientFullVOs, originBills);
                        // 构造返回数据
                        return transferTool.getBillForToClient(retvos);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        public BankloanBillVO[] pubquerybills(IQueryScheme queryScheme)
                        throws BusinessException {
                BankloanBillVO[] bills = null;
                try {
                        this.preQuery(queryScheme);
                        BillLazyQuery<BankloanBillVO> query = new BillLazyQuery<BankloanBillVO>(
                                        BankloanBillVO.class);
                        bills = query.query(queryScheme, null);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return bills;
        }

        /**
         * 由子类实现，查询之前对queryScheme进行加工，加入自己的逻辑
         * 
         * @param queryScheme
         */
        protected void preQuery(IQueryScheme queryScheme) {
                // 查询之前对queryScheme进行加工，加入自己的逻辑
        }

        // 提交
        public BankloanBillVO[] pubsendapprovebills(
                        BankloanBillVO[] clientFullVOs, BankloanBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
        BillTransferTool<BankloanBillVO> transferTool =
                new BillTransferTool<BankloanBillVO>(clientFullVOs);
                AceBankloanHVOSendApproveBP bp = new AceBankloanHVOSendApproveBP();
                BankloanBillVO[] retvos = bp.sendApprove(clientFullVOs, originBills);
                return retvos;
        }

        // 收回
        public BankloanBillVO[] pubunsendapprovebills(
                        BankloanBillVO[] clientFullVOs, BankloanBillVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
                BillTransferTool<BankloanBillVO> transferTool =
                        new BillTransferTool<BankloanBillVO>(clientFullVOs);
                AceBankloanHVOUnSendApproveBP bp = new AceBankloanHVOUnSendApproveBP();
                BankloanBillVO[] retvos = bp.unSend(clientFullVOs, originBills);
                return retvos;
        };

        // 审批
        public BankloanBillVO[] pubapprovebills(BankloanBillVO[] clientFullVOs,
                        BankloanBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankloanBillVO> transferTool =
                        new BillTransferTool<BankloanBillVO>(clientFullVOs);
                AceBankloanHVOApproveBP bp = new AceBankloanHVOApproveBP();
                BankloanBillVO[] retvos = bp.approve(clientFullVOs, originBills);
                return retvos;
        }

        // 弃审

        public BankloanBillVO[] pubunapprovebills(BankloanBillVO[] clientFullVOs,
                        BankloanBillVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<BankloanBillVO> transferTool =
                        new BillTransferTool<BankloanBillVO>(clientFullVOs);
                AceBankloanHVOUnApproveBP bp = new AceBankloanHVOUnApproveBP();
                BankloanBillVO[] retvos = bp.unApprove(clientFullVOs, originBills);
                return retvos;
        }

}